'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildInputObjectConfigFieldMap = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = buildInputObject;

var _type = require('graphql/type');

var _buildASTSchema = require('graphql/utilities/buildASTSchema');

var _produceType = require('./produceType');

var _produceType2 = _interopRequireDefault(_produceType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var buildInputObjectConfigFieldMap = exports.buildInputObjectConfigFieldMap = function buildInputObjectConfigFieldMap(inputObjectAST, types) {
  return inputObjectAST.fields.reduce(function (map, inputValueAST) {
    var name = inputValueAST.name.value;
    var type = (0, _produceType2.default)(inputValueAST.type, types);
    var defaultValue = inputValueAST.defaultValue;
    var description = (0, _buildASTSchema.getDescription)(inputValueAST);
    var inputObjectFieldConfig = { type: type };
    if (defaultValue !== null) {
      inputObjectFieldConfig.defaultValue = (0, _type.getNamedType)(type).parseLiteral(defaultValue);
    }
    if (description) inputObjectFieldConfig.description = description;
    return _extends({}, map, _defineProperty({}, name, inputObjectFieldConfig));
  }, {});
};

function buildInputObject(inputObjectAST, _, types) {
  var inputObjectTypeConfig = {
    name: inputObjectAST.name.value,
    fields: function fields() {
      return buildInputObjectConfigFieldMap(inputObjectAST, types);
    }
  };
  var description = (0, _buildASTSchema.getDescription)(inputObjectAST);
  if (description) inputObjectTypeConfig.description = description;
  return new _type.GraphQLInputObjectType(inputObjectTypeConfig);
}