'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildOperation = undefined;
exports.default = buildSchema;

var _type = require('graphql/type');

var _produceType = require('./produceType');

var _produceType2 = _interopRequireDefault(_produceType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var buildOperation = exports.buildOperation = function buildOperation(schemaAST, operation, types) {
  var operationAST = schemaAST.operationTypes.find(function (ast) {
    return ast.operation === operation;
  });
  return operationAST && (0, _produceType2.default)(operationAST.type, types);
};

function buildSchema(schemaAST) {
  var _ref = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var types = _ref.types;
  var directives = _ref.directives;
  var typeDeps = arguments[2];

  var query = buildOperation(schemaAST, 'query', typeDeps);
  var mutation = buildOperation(schemaAST, 'mutation', typeDeps);
  var subscription = buildOperation(schemaAST, 'subscription', typeDeps);
  var schemaConfig = { types: types, directives: directives };
  if (query) schemaConfig.query = query;
  if (mutation) schemaConfig.mutation = mutation;
  if (subscription) schemaConfig.subscription = subscription;
  return new _type.GraphQLSchema(schemaConfig);
}